CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  byteLimit = 100

VAR
  byte b_RxString[byteLimit]

  byte b_prefix[byteLimit]
  byte b_suffix[byteLimit]
  long l_var1
  long l_var1value

OBJ
  pst : "Parallax Serial Terminal"
  n : "Numbers"

PUB Main

  pst.Start(115_200)
  waitcnt(clkfreq*1 + cnt)
  pst.Clear
  
  l_var1 := string("value1")
  l_var1value := 0

  repeat
   
    pst.Str(String(pst#NL, "Enter a name, then an equals sign and then their age: "))
    pst.StrIn(@b_RxString)
    pst.Str(String(pst#NL, "You typed: "))
    pst.Str(@b_RxString)
    pst.Str(String(pst#NL))

    DelimiterFinder(@b_RxString)
    
    

PUB DelimiterFinder(RxStringAddr) : idx | c                                            

  repeat
    ifnot c := byte[RxStringAddr][idx++]                ' ifnot c, itterate to the next byte in byte[RxStringAddr] ?
      pst.Str(String("aborted"))
      pst.str(string(pst#NL))
      return -1

    pst.char(c)
    pst.str(string(pst#NL))  
  until c == "="             ' this character can be changed to a | if you'd like

' idx points to the character after the delimiter, copy prefix
  bytemove(@b_prefix, RxStringAddr, --idx)                ' copy from RxStringAddr to @prefix, stop 1 byte before the value of idx

' add terminator
  b_prefix[idx] := 0

' advance pointer, skip delimiter (+1)
  RxStringAddr += idx + 1                               ' RxStringAddr := RxStringAddr[idx + 1]

' copy tail including the existing terminator (+1)
  bytemove(@b_suffix, RxStringAddr, strsize(RxStringAddr) +1)                     ' copy from RxStringAddr to @suffix, size + 1 to have the terminating 0

' display prefix/suffix/index
  pst.Char(pst#NL)
  pst.Str(@b_prefix)
  pst.Char(pst#NL)
  pst.Str(@b_suffix)
  pst.Char(pst#NL)
  pst.Dec(idx)
  pst.Char(pst#NL)

{1}  variableUpdator(@b_prefix, @b_suffix)


{2}
PUB variableUpdator(preAddr, sufAddr) ' variableUpdator(@prefix, @suffix)

  if strcomp(preAddr, l_var1) 'strcomp(@prefix, var1)
{3}    
{4} l_var1value := n.FromStr(sufAddr, %000_000_000_0_0_000000_01010) ' n.FromStr(@suffix, %000_000_000_0_0_000000_01010)    ' converts from a string to a dec
       
  else
    return -1


  